/*
			Copyright (c) 1993 by
			Advanced Visual Systems Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under Perforce control
	$Id: //depot/express/fcs992/modules/rd_fld.c#1 $
*/
#include <stdio.h>

#include <avs/util.h>
#include <avs/err.h>
#include <avs/om.h>
#include <avs/math.h>
#include <avs/dtype.h>
#include <avs/fld.h>


int DVread_field_update(OMobj_id elem_id )
{
    OMobj_id file, out, temp; 
    char *filename;
    int portable, swap, stat, flip;
    FILE     *pf, *FILEfopen();

    filename = NULL;
    file = OMfind_subobj(elem_id, OMstr_to_name("filename"), OM_OBJ_RD);
    if (OMget_str_val(file, &filename, 0) != 1)
      return(0);

    out = OMfind_subobj(elem_id, OMstr_to_name("out"), OM_OBJ_RW);

    OMget_name_int_val(elem_id,  OMstr_to_name("portable"), &portable);
    OMget_name_int_val(elem_id,  OMstr_to_name("swap"), &swap);
    OMget_name_int_val(elem_id,  OMstr_to_name("flip"), &flip);

    if (filename[0] == '\0')
	    return(1);
    
    if (!(pf = FILEfopen(filename, SIO_R_BIN))) {
	    ERRerror("Read Field",1,ERR_ORIG, "Can't open data file: %s",
		     filename); 
	    return(0);
    } 
    
    stat =  RFread_field(elem_id, &temp, pf, filename, portable, swap, flip);

    fclose(pf);

    if (filename) 
	    free(filename);
    if (stat != 1)
	    return(stat);

    stat =  OMset_obj_ref_mode(out, OM_OBJ_REF);
    if (stat < 1)
	    return(stat);
    stat = OMset_obj_ref(out, temp, 0);

    return(stat);
}
